﻿//Copyright: (c)Education Software Solutions Limited (ESS). 1984 - 2022
//          : This code has been written by ESS for use within its own systems.
//          : It is an unpublished proprietary work and as such it is illegal
//          : for it to be reproduced by any means or used without the express
//          : written permission of ESS.
//
//Grant for technical integrators
//
//Without prejudice to the copyright, ESS grants those persons or organisations
//who hold a current technical integrator agreement to use parts of the code
//with or without modification in order to provide a solution or service to
//mutual customers within the terms of their contract with ESS for commercial purposes.
//
//Those without a current technical agreement may use the code for a proof of concept
//but are strictly denied any rights to use the code for commercial gain or other
//purpose beyond a proof of concept.
//
//The code is provided as is and without warranty.
//The code is provide to demonstrate how solutions might be created and
//is not intended to meet any specific need without modification
//
//The use of the code is subject to our fair usage policy and must not be
//used to damage or attempt to damage ESS systems or services.
//
//All keys and secrets within the code are restricted to a demonstration sandbox
//and cannot access real data.  Data supplied is as is
//
//Contact partner.management@educationsoftwaresolutions.co.uk to engage with us.

using System;
using System.Collections.Generic;
using System.Text;
using PostitCore;
using PostitCommon;
using System.Net.Http;
namespace VMC
{
    public class SchoolTokens
    {
        /// <summary>
        /// Gets a token for RAP / One Roster or DeX  -
        /// 
        /// </summary>
        /// <param name="httpClient"></param>
        /// <param name="clientId"></param>
        /// <param name="secret"></param>
        /// <param name="orgId"></param>
        /// <returns></returns>
        public static string SchoolOneRosterDataAccessToken(HttpClient httpClient,string clientId, string secret,  string orgId)
        {
            string scopes = "partner organisation onerosterapi rapapi"; // partner organisation rapapi onerosterapi
            AuthRequest arq = new AuthRequest();
            string rc = "";
            arq.Client_ID = clientId;
            arq.Secret = secret;
            arq.Organisation_ID = orgId; // Must have one
            arq.STS = "https://sts.sims.co.uk/connect/token";
            arq.Scopes = scopes;
            BearerToken bt = new BearerToken(arq, httpClient);
            rc = bt.Token;
            return rc;
        }
        /// <summary>
        /// Gets a token for DeX  -
        /// 
        /// </summary>
        /// <param name="httpClient"></param>
        /// <param name="clientId"></param>
        /// <param name="secret"></param>
        /// <param name="orgId"></param>
        /// <returns></returns>
        public static string SchoolDexDataAccessToken(HttpClient httpClient, string clientId, string secret, string orgId)
        {
            string scopes = "partnerserverapplication";
            AuthRequest arq = new AuthRequest();
            string rc = "";
            arq.Client_ID = clientId;
            arq.Secret = secret;
            arq.Organisation_ID = orgId; // Must have one
            arq.STS = "https://sts.sims.co.uk/connect/token";
            arq.Scopes = scopes;
            BearerToken bt = new BearerToken(arq, httpClient);
            rc = bt.Token;
            return rc;
        }
    }
}
